import { TestBed } from '@angular/core/testing';
import { HttpClientTestingModule, HttpTestingController } from '@angular/common/http/testing';

import { IMetadataValue } from '../metadata-value.model';
import { sampleWithRequiredData, sampleWithNewData, sampleWithPartialData, sampleWithFullData } from '../metadata-value.test-samples';

import { MetadataValueService } from './metadata-value.service';

const requireRestSample: IMetadataValue = {
  ...sampleWithRequiredData,
};

describe('MetadataValue Service', () => {
  let service: MetadataValueService;
  let httpMock: HttpTestingController;
  let expectedResult: IMetadataValue | IMetadataValue[] | boolean | null;

  beforeEach(() => {
    TestBed.configureTestingModule({
      imports: [HttpClientTestingModule],
    });
    expectedResult = null;
    service = TestBed.inject(MetadataValueService);
    httpMock = TestBed.inject(HttpTestingController);
  });

  describe('Service methods', () => {
    it('should find an element', () => {
      const returnedFromService = { ...requireRestSample };
      const expected = { ...sampleWithRequiredData };

      service.find(123).subscribe(resp => (expectedResult = resp.body));

      const req = httpMock.expectOne({ method: 'GET' });
      req.flush(returnedFromService);
      expect(expectedResult).toMatchObject(expected);
    });

    it('should create a MetadataValue', () => {
      const metadataValue = { ...sampleWithNewData };
      const returnedFromService = { ...requireRestSample };
      const expected = { ...sampleWithRequiredData };

      service.create(metadataValue).subscribe(resp => (expectedResult = resp.body));

      const req = httpMock.expectOne({ method: 'POST' });
      req.flush(returnedFromService);
      expect(expectedResult).toMatchObject(expected);
    });

    it('should update a MetadataValue', () => {
      const metadataValue = { ...sampleWithRequiredData };
      const returnedFromService = { ...requireRestSample };
      const expected = { ...sampleWithRequiredData };

      service.update(metadataValue).subscribe(resp => (expectedResult = resp.body));

      const req = httpMock.expectOne({ method: 'PUT' });
      req.flush(returnedFromService);
      expect(expectedResult).toMatchObject(expected);
    });

    it('should partial update a MetadataValue', () => {
      const patchObject = { ...sampleWithPartialData };
      const returnedFromService = { ...requireRestSample };
      const expected = { ...sampleWithRequiredData };

      service.partialUpdate(patchObject).subscribe(resp => (expectedResult = resp.body));

      const req = httpMock.expectOne({ method: 'PATCH' });
      req.flush(returnedFromService);
      expect(expectedResult).toMatchObject(expected);
    });

    it('should return a list of MetadataValue', () => {
      const returnedFromService = { ...requireRestSample };

      const expected = { ...sampleWithRequiredData };

      service.query().subscribe(resp => (expectedResult = resp.body));

      const req = httpMock.expectOne({ method: 'GET' });
      req.flush([returnedFromService]);
      httpMock.verify();
      expect(expectedResult).toMatchObject([expected]);
    });

    it('should delete a MetadataValue', () => {
      const expected = true;

      service.delete(123).subscribe(resp => (expectedResult = resp.ok));

      const req = httpMock.expectOne({ method: 'DELETE' });
      req.flush({ status: 200 });
      expect(expectedResult).toBe(expected);
    });

    describe('addMetadataValueToCollectionIfMissing', () => {
      it('should add a MetadataValue to an empty array', () => {
        const metadataValue: IMetadataValue = sampleWithRequiredData;
        expectedResult = service.addMetadataValueToCollectionIfMissing([], metadataValue);
        expect(expectedResult).toHaveLength(1);
        expect(expectedResult).toContain(metadataValue);
      });

      it('should not add a MetadataValue to an array that contains it', () => {
        const metadataValue: IMetadataValue = sampleWithRequiredData;
        const metadataValueCollection: IMetadataValue[] = [
          {
            ...metadataValue,
          },
          sampleWithPartialData,
        ];
        expectedResult = service.addMetadataValueToCollectionIfMissing(metadataValueCollection, metadataValue);
        expect(expectedResult).toHaveLength(2);
      });

      it("should add a MetadataValue to an array that doesn't contain it", () => {
        const metadataValue: IMetadataValue = sampleWithRequiredData;
        const metadataValueCollection: IMetadataValue[] = [sampleWithPartialData];
        expectedResult = service.addMetadataValueToCollectionIfMissing(metadataValueCollection, metadataValue);
        expect(expectedResult).toHaveLength(2);
        expect(expectedResult).toContain(metadataValue);
      });

      it('should add only unique MetadataValue to an array', () => {
        const metadataValueArray: IMetadataValue[] = [sampleWithRequiredData, sampleWithPartialData, sampleWithFullData];
        const metadataValueCollection: IMetadataValue[] = [sampleWithRequiredData];
        expectedResult = service.addMetadataValueToCollectionIfMissing(metadataValueCollection, ...metadataValueArray);
        expect(expectedResult).toHaveLength(3);
      });

      it('should accept varargs', () => {
        const metadataValue: IMetadataValue = sampleWithRequiredData;
        const metadataValue2: IMetadataValue = sampleWithPartialData;
        expectedResult = service.addMetadataValueToCollectionIfMissing([], metadataValue, metadataValue2);
        expect(expectedResult).toHaveLength(2);
        expect(expectedResult).toContain(metadataValue);
        expect(expectedResult).toContain(metadataValue2);
      });

      it('should accept null and undefined values', () => {
        const metadataValue: IMetadataValue = sampleWithRequiredData;
        expectedResult = service.addMetadataValueToCollectionIfMissing([], null, metadataValue, undefined);
        expect(expectedResult).toHaveLength(1);
        expect(expectedResult).toContain(metadataValue);
      });

      it('should return initial array if no MetadataValue is added', () => {
        const metadataValueCollection: IMetadataValue[] = [sampleWithRequiredData];
        expectedResult = service.addMetadataValueToCollectionIfMissing(metadataValueCollection, undefined, null);
        expect(expectedResult).toEqual(metadataValueCollection);
      });
    });

    describe('compareMetadataValue', () => {
      it('Should return true if both entities are null', () => {
        const entity1 = null;
        const entity2 = null;

        const compareResult = service.compareMetadataValue(entity1, entity2);

        expect(compareResult).toEqual(true);
      });

      it('Should return false if one entity is null', () => {
        const entity1 = { id: 123 };
        const entity2 = null;

        const compareResult1 = service.compareMetadataValue(entity1, entity2);
        const compareResult2 = service.compareMetadataValue(entity2, entity1);

        expect(compareResult1).toEqual(false);
        expect(compareResult2).toEqual(false);
      });

      it('Should return false if primaryKey differs', () => {
        const entity1 = { id: 123 };
        const entity2 = { id: 456 };

        const compareResult1 = service.compareMetadataValue(entity1, entity2);
        const compareResult2 = service.compareMetadataValue(entity2, entity1);

        expect(compareResult1).toEqual(false);
        expect(compareResult2).toEqual(false);
      });

      it('Should return false if primaryKey matches', () => {
        const entity1 = { id: 123 };
        const entity2 = { id: 123 };

        const compareResult1 = service.compareMetadataValue(entity1, entity2);
        const compareResult2 = service.compareMetadataValue(entity2, entity1);

        expect(compareResult1).toEqual(true);
        expect(compareResult2).toEqual(true);
      });
    });
  });

  afterEach(() => {
    httpMock.verify();
  });
});
